/*
** TleenX2 (Tlen.pl Client)
** Copyright (c) 2002-2003 Hubert Sokoowski <who_ami@tlen.pl>
**                         Pawe Biliski <rael@fr.pl>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
*/


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/param.h>
#include <gtk/gtk.h>
#include <signal.h>

#include "interface.h"
#include "support.h"
#include "windows.h"
#include "conffile.h"
#include "messages.h"
#include "lista.h"
#include "users.h"
#include "groups.h"
#include "docklet.h"
#include "utils.h"
#include "jabby.h"


GtkWidget *window1;
GtkWidget *window_login;
GtkWidget *window_profiles;
GtkWidget *window_profile;
GtkWidget *window_search;
GtkWidget *window_message;
GtkWidget *window_archive;
GtkWidget *window_prefs;
GtkWidget *window_card;
GtkWidget *window_contacts;
GtkWidget *window_desc;
GtkWidget *fileselection;
GtkWidget *colorselection;
GtkWidget *treeview1, *notebook1, *scroll1;
GtkWidget *status_docklet = NULL;

struct tlen_session *session;//sesja tlenu
gchar *pname;//nazwa profilu
gchar *desc;//opis
struct profile *profile;
gint status;
gint posx,posy, width, height;
gchar *datefg, *nickfg, *textfg, *textbg;
//gchar *jabberjid, *jabberpassword;
//gchar *login, *password;//tlen
gchar *sounds[MAX_SOUNDS], *playpath, *smspath;
GtkWidget *icons[MAX_ICONS];
GtkWidget *j_icons[J_MAX_ICONS];//ikonki jabbera
GtkWidget *wp_icons[J_MAX_ICONS];//ikonki wpkontakt
GList *users_list;
GList *groups_list;
GList *expanders_list;
GList *pubdir_list;
GList *talks_list;//lista otwartych okienek z rozmowami
GList *profiles_list;
GList *chat_list;
GList *contacts_list;
GList *messages_list;
gint chatbuf;
gboolean cant_stop;
gboolean online, beep;

gint timerid, timerid2, timerid3;
guint32 preferences;//preferencje

gchar *job[] = {
  "",
  "ucze",
  "student",
  "rolnik",
  "meneder",
  "specjalista",
  "urzdnik",
  "bezrobotny",
  "emeryt,rencista",
  "gospodyni",
  "nauczyciel",
  "lekarz",
  "inny"
};
gchar *plans[] = {
  "", "kino"
};

gchar *opisy[7]={"Dostpny", "Wrc pniej", "Zaraz wracam",
  "Jestem zajty", "Porozmawiajmy" , "Niedostpny", "Niedostpny"};

gchar *statusy[7]={"dostpny", "wrc pniej", "zaraz wracam",
  "jestem zajty", "porozmawiajmy" , "niewidoczny", "niedostpny"};

gchar *j_statusy[]={"Available", "Chatty", "Do not disturb",
  "Away", "Will be later", "Unavailable", "Unavailable"};

void clear_lists()
{
  chat_list_flush();
  messages_list_clear();//FIXME zapisz nieprzeczytane wiadomosci do pliku
  expanders_list_clear();
  talks_list_clear();
  contacts_list_clear();
  groups_list_clear();
  users_list_clear();
}

void clear_pointers()
{
  gint i;

  if(desc)
  {
    g_free(desc);
    desc=NULL;
  }
  if(pname)
  {
    g_free(pname);
    pname=NULL;
  }
  g_free(datefg);
  datefg = NULL;
  g_free(nickfg);
  nickfg = NULL;
  g_free(textfg);
  textfg = NULL;
  g_free(textbg);
  textbg = NULL;
  g_free(playpath);
  playpath = NULL;
  g_free(smspath);
  smspath = NULL;
  for(i=0; i<MAX_SOUNDS; i++)
  {
    g_free(sounds[i]);
    sounds[i] = NULL;
  }
  profile = NULL;
}

static void create_icons()
{
  gint i;

  icons[0]=create_icon(0);
  icons[1]=create_icon(1);
  for(i = TLEN_STATUS_AVAILABLE; i <= TLEN_STATUS_UNAVAILABLE; i++)
  {
    icons[i]=create_icon(i);
    gtk_widget_show(icons[i]);
  }
  for (i = JABBY_PRESENCE_UNAVAILABLE; i <= JABBY_PRESENCE_INVISIBLE; i++)
  {
    j_icons[i] = j_create_icon(i);
    gtk_widget_show(j_icons[i]);
    wp_icons[i] = wp_create_icon(i);
    gtk_widget_show(wp_icons[i]);
  }
}

int
main (int argc, char *argv[])
{

  signal(SIGCHLD, SIG_IGN);//zeby zapobiec procesom zombie
  gtk_set_locale ();
  gtk_init (&argc, &argv);
  if (!g_thread_supported ()) g_thread_init (NULL);
  else
  {
    g_print("no threads in glib\n");
    exit(1);
  }


  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

  //ikonki
  create_icons();

  create_docklet();

  if(last_login())
  {
    load_profiles();
    window1_open();
  }
  else
    my_create_window_login ();

  gtk_main ();
  return 0;
}

