/*
** TleenX2 (Tlen.pl Client)
** Copyright (c) 2002-2003 Hubert Sokoowski <who_ami@tlen.pl>
**                         Pawe Biliski <rael@fr.pl>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
*/

#include "main.h"
#include "windows.h"
#include "utils.h"
#include "chat.h"
#include "lista.h"
#include "docklet.h"
#include "jabber.h"

void on_menu_user_mesg(const gchar *jid)
{
  message_send((gchar*)jid, NULL);
}

void on_menu_user_check(const gchar *jid)
{
  if(!window_search)
    my_create_window_search();
  window_search_check((gchar *) jid);
}

void on_menu_user_edit(struct user *user)
{
  contact_add(user->jid, user->type);
}

void on_menu_user_delete(struct user *user)
{
  switch(user->type)
  {
    case USER_TLEN:
      tlen_removecontact(session,user->jid);
      if(!strcmp(user->subscription, "to"))
        tlen_request_unsubscribe(session, user->jid);
      break;
    case USER_JABBER:
    case USER_WP:
      jabber_contact_delete(user);
      break;
    case USER_GG:
      break;
  }
  del_user(user->jid);
  refresh_gui();
}

void on_menu_user_chat(struct user *user)
{
  struct talk *talk;

  if((talk = get_talk(user->jid)))
  {
    gtk_window_deiconify(GTK_WINDOW(talk->window));
    return;
  }
  my_create_window_chat(user->jid);
  talk=get_talk(user->jid);
  chat_set_title(talk, 0);
}


void menu_status_response(gchar *s)
{
  gint status2=0;

  if(!strcmp(s,"1"))
    status2=TLEN_STATUS_AVAILABLE;
  if(!strcmp(s,"2"))
    status2=TLEN_STATUS_CHATTY;
  if(!strcmp(s,"3"))
    status2=TLEN_STATUS_DND;
  if(!strcmp(s,"4"))
    status2=TLEN_STATUS_AWAY;
  if(!strcmp(s,"5"))
    status2=TLEN_STATUS_EXT_AWAY;
  if(!strcmp(s,"6"))
    status2=TLEN_STATUS_INVISIBLE;
  if(!strcmp(s,"7"))
  {
    if(cant_stop)
      return;
    work_offline();
    return;
  }
  if(!strcmp(s,"8"))
  {
    my_create_window_desc();
    return;
  }
  status_button_set(status2);
  if(status2 == status)
    return;
  status=status2;
  if(online)
  {
    if(desc)
      tlen_presence(session,status,desc);
    else
      tlen_presence(session,status, opisy[status-2]);
    gtk_window_set_icon(GTK_WINDOW(window1),
                        gtk_image_get_pixbuf(GTK_IMAGE(icons[status])));
    docklet_change_status(status);
  }
  else
    work_online();
}

gint menu_show(GtkWidget *menu, GdkEvent *event)
{
  if (event->type == GDK_BUTTON_PRESS)
  {
    GdkEventButton *bevent = (GdkEventButton *) event;

    gtk_menu_popup (GTK_MENU (menu), NULL, NULL, NULL, NULL,
                    bevent->button, bevent->time);
    return TRUE;
  }
  return FALSE;
}

void menu_tlen_show()
{
}

void menu_status_show()
{
}

void
on_wyszukiwanie1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if(!online)
  {
    info("Musisz by poczony z serwerem.");
    return;
  }
  if(!window_search)
    my_create_window_search();

}

void
on_wyslij_wiadomosc_activate              (GtkMenuItem     *menuitem,
                                           gpointer         user_data)
{
  message_send(NULL, NULL);
}

void
on_wizytowka_activate              (GtkMenuItem     *menuitem,
                                    gpointer         user_data)
{
  my_create_window_card();
}

void
on_kontakty_activate              (GtkMenuItem     *menuitem,
                                   gpointer         user_data)
{
  my_create_window_contacts();
}


void
on_dodaj_kontakt1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

  if(!online)
  {
    info("Musisz by poczony z serwerem.");
    return;
  }
  contact_add(NULL, USER_TLEN);
}


void
on_archiwum1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if(!window_archive)
    my_create_window_archive();

}


void
on_ustawienia1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if(!online)
  {
    info("Musisz by poczony z serwerem.");
    return;
  }
  if(!window_prefs)
    my_create_window_prefs();

}


void
on_o_programie1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  my_create_window_about();
}


void
on_wyloguj_profil1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
//  GtkWidget *window;
  if(cant_stop)
  {
    info("Nie mona wykona teraz tej operacji.");
    return;
  }

  wyloguj();
  my_create_window_login();
}


void
on_wyj__cie1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if(cant_stop)
  {
    info("Nie mona wykona teraz tej operacji.");
    return;
  }
  wyjscie();

}




